#include <stdlib.h>
#include <vector>
#include <algorithm>
#include "basicdefs.h"
#include "integerPartitions.h"

using namespace std;

void addTo(vector<vector<int> > &mat1, vector<vector<int> > &mat2){
  unsigned int size1=mat1.size();
  mat1.resize(mat1.size()+mat2.size());
  for(unsigned int iI=0; iI < mat2.size(); iI++){
    mat1[size1+iI]=mat2[iI];
  }
}

// find integer partitions of n into at most k parts
vector<vector<int> > partition_n_k(int n, int k){
  vector<vector<int> > completeList;
  vector<vector<int> > currentList;
  vector<int> tmp(1), addPos, subtractPos;

  tmp[0]=n;
  completeList.push_back(tmp);
  unsigned int iI, iS, iA;
  int explored = 0;

  while(explored < completeList.size()){
    for(iI=explored; iI < completeList.size(); iI++){
      explored++;
      tmp=completeList[iI];
      if(tmp.size()==1 && n > 1){
	tmp[0]--;
	tmp.push_back(1);
	currentList.push_back(tmp);
      }
      else{
	if(tmp[0] > tmp[1]){
	  // add to the rightmost block, given that it does not violate monotonicity,
	  if((tmp.size() == 2  && tmp[0] > tmp[1]+1) || (tmp.size() > 2 && tmp.back() < tmp[tmp.size()-2]) ){
	    tmp[0]--;
	    tmp[tmp.size()-1]++;
	    currentList.push_back(tmp);
	    tmp[tmp.size()-1]--;
	    tmp[0]++;
	  }
	  // add a new block 
	  if(tmp.size() < k){
	    tmp[0]--;
	    tmp.push_back(1);
	    currentList.push_back(tmp);
	  }
	}
      }	  
    }
    addTo(completeList,currentList);
    currentList.clear();
  }

  return completeList;
}
    
    
